/**
 * @copyright 2020 {@link http://infiniteautomation.com|Infinite Automation Systems, Inc.} All rights reserved.
 * @author Luis Güette
 */

define(['angular', 'require'], (angular, require) => {
    'use strict';

    const DEFAULT_CENTER = {
        lat: 35.618379,
        lon: -78.413052
    }

    const DEFAULT_ZOOM = 7

    class MapController {
        static get $$ngIsClass() {
            return true;
        }

        static get $inject() {
            return [];
        }

        constructor() {}

        $onInit() {
            if (!this.center) {
                this.center = DEFAULT_CENTER;
            }

            if (!this.zoom) {
                this.zoom = DEFAULT_ZOOM;
            }
        }

        addEventListener(map) {
            map.on('popupclose', event => {
                this.selectUnit(null);
            });
        }

        selectUnit(unit) {
            this.onSelectUnit({unit: unit});
        }
    }

    return {
        bindings: {
            center: '<?',
            zoom: '<?',
            options: '<?',
            units: '<',
            onSelectUnit: '&'
        },
        controller: MapController,
        templateUrl: require.toUrl('./map.html')
    };
});
